image: archlinux/archlinux:latest

stages:
  - build_proto
  - build
  - deploy

before_script:
  - pacman -Syu --noconfirm jdk17-openjdk base-devel rust zip curl protobuf
  - export GRADLE_USER_HOME=`pwd`/.gradle
  - export JAVA_HOME=/usr/lib/jvm/java-17-openjdk

default:
  tags:
    - saas-linux-large-amd64

cache:
  paths:
    - .gradle/wrapper
    - .gradle/caches

build_docs:
  stage: build
  script:
    - pacman -Syu --noconfirm python python-pip
    # execute sphinx build
    - cd docs
    - python3 -m pip install --break-system-packages -r requirements.txt
    - python3 -m sphinx -b html -a . ../public

build:
  stage: build_proto
  script:
    - ./gradlew clean executeConverter executeConverterExtensions copyProto
  artifacts:
    paths:
      - "proto/**/*.proto"
      - "java-proto/src/main/proto/**/*.proto"
      - "kotlin-proto/src/main/proto/**/*.proto"
      - "rust/protosdc-proto/src/proto/**/*.proto"
      - "kotlin-model/src/main/kotlin/org/**/*.kt"
      - "proto-kotlin-mapper/src/main/kotlin/org/**/*.kt"
      - "rust/protosdc-biceps/src/biceps/**/*.rs"
      - "rust/protosdc-biceps/src/extension/**/*.rs"
      - "rust/protosdc-biceps/src/xml/**/*.rs"
    expire_in: 1 week

build_javascript:
  stage: build
  script:
    - ./build_javascript.sh

build_python:
  stage: build
  script:
    - ./build_python.sh

build_jvm:
  stage: build
  script:
    - ./gradlew assemble

build_rust:
  stage: build
  script:
    - ./build_rust.sh
  dependencies:
    - build

build_proto_package:
  stage: build
  dependencies:
    - build
  script:
    - ./build_proto.sh
  artifacts:
    paths:
      - "proto-model_*.zip"
    expire_in: 1 week

deploy_python:
  stage: deploy
  only:
    - master
  script:
    - ./build_python.sh --deploy

deploy_javascript:
  stage: deploy
  only:
    - master
  script:
    - echo "//${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}" >> javascript/.npmrc
    - ./build_javascript.sh --deploy

deploy_jvm:
  stage: deploy
  only:
    - master
  script:
    - ./gradlew generateProto assemble publish

deploy_proto:
  stage: deploy
  dependencies:
    - build_proto_package
  only:
    - master
  script:
    - ./build_proto.sh --deploy

pages:
  stage: deploy
  script:
    - pacman -Syu --noconfirm python python-pip
    - cd docs
    - python3 -m pip install --break-system-packages -r requirements.txt
    - python3 -m sphinx -b html -a . ../public

  artifacts:
    paths:
      - public

  only:
    - master